org.apache.sis.referencing.crs

## Class DefaultVerticalCRS

- Object
- - FormattableObject
  - - AbstractIdentifiedObject
    - - AbstractReferenceSystem
      - - AbstractCRS
        - - DefaultVerticalCRS

- All Implemented Interfaces:
    Serializable, Deprecable, LenientComparable, CoordinateReferenceSystem, SingleCRS, VerticalCRS, IdentifiedObject, ReferenceSystem

      public class DefaultVerticalCRS
      extends AbstractCRS
      implements VerticalCRS

  A 1-dimensional coordinate reference system used for recording heights or depths. Vertical CRSs make use of the direction of gravity to define the concept of height or depth, but the relationship with gravity may not be straightforward.

  Used with datum type: Vertical.
  Used with coordinate system type: Vertical.

  Immutability and thread safety
  This class is immutable and thus thread-safe if the property values (not necessarily the map itself), the coordinate system and the datum instances given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.
  Since:
    0.4
  See Also:
    `DefaultVerticalDatum`, `DefaultVerticalCS`, `GeodeticAuthorityFactory​.createVerticalCRS(String)`, Serialized Form

  Defined in the `sis-referencing` module

- - ### Field Summary

    - ### Fields inherited from class AbstractIdentifiedObject

      `DEPRECATED_KEY, LOCALE_KEY`

    - ### Fields inherited from interface ReferenceSystem

      `DOMAIN_OF_VALIDITY_KEY, SCOPE_KEY`

    - ### Fields inherited from interface IdentifiedObject

      `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `DefaultVerticalCRS(Map<String,?> properties, VerticalDatum datum, VerticalCS cs)` Creates a coordinate reference system from the given properties, datum and coordinate system.
    `protected` | `DefaultVerticalCRS(VerticalCRS crs)` Constructs a new coordinate reference system with the same values than the specified one.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DefaultVerticalCRS` | `castOrCopy(VerticalCRS object)` Returns a SIS coordinate reference system implementation with the same values than the given arbitrary implementation.
    `DefaultVerticalCRS` | `forConvention(AxesConvention convention)` Returns a coordinate reference system equivalent to this one but with axes rearranged according the given convention.
    `protected String` | `formatTo(Formatter formatter)` Formats this CRS as a Well Known Text `VerticalCRS[…]` element.
    `VerticalCS` | `getCoordinateSystem()` Returns the coordinate system.
    `VerticalDatum` | `getDatum()` Returns the datum.
    `Class<? extends VerticalCRS>` | `getInterface()` Returns the GeoAPI interface implemented by this class.

    - ### Methods inherited from class AbstractCRS

      `castOrCopy, computeHashCode, equals`

    - ### Methods inherited from class AbstractReferenceSystem

      `getDomainOfValidity, getScope`

    - ### Methods inherited from class AbstractIdentifiedObject

      `castOrCopy, equals, getAlias, getDescription, getIdentifiers, getName, getRemarks, hashCode, isDeprecated, isHeuristicMatchForName`

    - ### Methods inherited from class FormattableObject

      `print, toString, toString, toWKT`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface ReferenceSystem

      `getDomainOfValidity, getScope`

    - ### Methods inherited from interface IdentifiedObject

      `getAlias, getIdentifiers, getName, getRemarks, toWKT`

- - ### Constructor Detail

    - #### DefaultVerticalCRS

          public DefaultVerticalCRS(Map<String,?> properties,
                                    VerticalDatum datum,
                                    VerticalCS cs)

      Creates a coordinate reference system from the given properties, datum and coordinate system. The properties given in argument follow the same rules than for the super-class constructor. The following table is a reminder of main (not all) properties:

      Recognized properties (non exhaustive list)
      Property name | Value type | Returned by
      --- | --- | ---
      "name" | `ReferenceIdentifier` or `String` | `AbstractIdentifiedObject.getName()`
      "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
      "identifiers" | `ReferenceIdentifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
      "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`
      "domainOfValidity" | `Extent` | `AbstractReferenceSystem.getDomainOfValidity()`
      "scope" | `InternationalString` or `String` | `AbstractReferenceSystem.getScope()`

      Parameters:
        `properties` - the properties to be given to the coordinate reference system.
        `datum` - the datum.
        `cs` - the coordinate system.
      See Also:
        `GeodeticObjectFactory​.createVerticalCRS(Map, VerticalDatum, VerticalCS)`

    - #### DefaultVerticalCRS

          protected DefaultVerticalCRS(VerticalCRS crs)

      Constructs a new coordinate reference system with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

      This constructor performs a shallow copy, i.e. the properties are not cloned.

      Parameters:
        `crs` - the coordinate reference system to copy.
      See Also:
        `castOrCopy(VerticalCRS)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultVerticalCRS castOrCopy(VerticalCRS object)

      Returns a SIS coordinate reference system implementation with the same values than the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getInterface

          public Class<? extends VerticalCRS> getInterface()

      Returns the GeoAPI interface implemented by this class. The SIS implementation returns `VerticalCRS​.class`.
      Note for implementors: Subclasses usually do not need to override this method since GeoAPI does not define `VerticalCRS` sub-interface. Overriding possibility is left mostly for implementors who wish to extend GeoAPI with their own set of interfaces.
      Overrides:
        `getInterface` in class `AbstractCRS`
      Returns:
        `VerticalCRS​.class` or a user-defined sub-interface.

    - #### getDatum

          public VerticalDatum getDatum()

      Returns the datum.
      Specified by:
        `getDatum` in interface `SingleCRS`
      Specified by:
        `getDatum` in interface `VerticalCRS`
      Returns:
        the datum.

    - #### getCoordinateSystem

          public VerticalCS getCoordinateSystem()

      Returns the coordinate system.
      Specified by:
        `getCoordinateSystem` in interface `CoordinateReferenceSystem`
      Specified by:
        `getCoordinateSystem` in interface `SingleCRS`
      Specified by:
        `getCoordinateSystem` in interface `VerticalCRS`
      Overrides:
        `getCoordinateSystem` in class `AbstractCRS`
      Returns:
        the coordinate system.

    - #### forConvention

          public DefaultVerticalCRS forConvention(AxesConvention convention)

      Returns a coordinate reference system equivalent to this one but with axes rearranged according the given convention. If this CRS is already compatible with the given convention, then this method returns `this`.
      Overrides:
        `forConvention` in class `AbstractCRS`
      Parameters:
        `convention` - the axes convention for which a coordinate reference system is desired.
      Returns:
        a coordinate reference system compatible with the given convention (may be `this`).
      See Also:
        `AbstractCS​.forConvention(AxesConvention)`

    - #### formatTo

          protected String formatTo(Formatter formatter)

      Formats this CRS as a Well Known Text `VerticalCRS[…]` element.
      Overrides:
        `formatTo` in class `AbstractCRS`
      Parameters:
        `formatter` - the formatter where to format the inner content of this WKT element.
      Returns:
        `"VerticalCRS"` (WKT 2) or `"Vert_CS"` (WKT 1).
      See Also:
        WKT 2 specification §10

Copyright © 2010–2017 The Apache Software Foundation. All rights reserved.